FSCK_FFS(8)

NAME
fsck_ffs - Fast File System consistency check and interactive repair

SYNOPSIS
fsck_ffs [-fnpy] [-b block#] [-c level] [-m mode] filesystem

DESCRIPTION
fsck_ffs performs interactive file system consistency checks and repairs the file system specified. It is normally invoked from fsck(8).

The kernel takes care that only a restricted class of innocuous file system inconsistencies can happen unless hardware or software failures intervene. These are limited to the following:

Unreferenced inodes
Link counts in inodes too large
Missing blocks in the free map
Blocks in the free map also in files
Counts in the super-block wrong

These are the only inconsistencies that fsck_ffs with the -p option will correct; if it encounters other inconsistencies, it exits with an abnormal return status and an automatic reboot will then fail. For each corrected inconsistency, one or more lines will be printed identifying the file system on which the correction will take place along with the nature of the correction. After successfully correcting a file system, fsck_ffs will print the number of files on that file system, the number of used and free blocks, and the percentage of fragmentation.

If sent a QUIT signal, fsck_ffs will finish the file system checks, then exit with an abnormal return status that causes an automatic reboot to fail. This is useful when you want to finish the file system checks during an automatic reboot, but do not want the machine to come up multiuser after the checks complete.

If sent an INFO signal, fsck_ffs will print a line to standard error indicating the name of the device currently being checked, the current phase number, and phase-specific progress information.

Without the -p option, fsck_ffs audits and interactively repairs inconsistent conditions for the filesystem. If the file system is inconsistent, the operator is prompted for concurrence before each correction is attempted. It should be noted that some of the corrective actions which are not correctable under the -p option will result in some loss of data. The amount and severity of data lost may be determined from the diagnostic output. The default action for each consistency correction is to wait for the operator to respond “yes” or “no”. If the operator does not have write permission on the file system, fsck_ffs will default to a -n action.

fsck has more consistency checks than its predecessors check, dcheck, fcheck, and icheck combined.

The following flags are interpreted by fsck_ffs:

-b block#
    Use the block# specified as the super block for the file system. If the primary superblock is corrupted, fsck_ffs tries to find a valid alternate superblock based on the information in the disklabel. If that fails, a number printed by newfs (using -N combined with the original flags used to create the filesystem) can be used as a value to this argument.

-c level
    Convert the file system to the specified level. Note that the level of a file system can only be raised. There are currently four levels defined:

    0   The file system is in the old (static table) format.

    1   The file system is in the new (dynamic table) format.

    2   The file system supports 32-bit UIDs and GIDs, short symbolic links are stored in the inode, and directories have an added field showing the file type.

    3   If maxcontig is greater than one, build the free segment maps to aid in finding contiguous sets of blocks. If maxcontig is equal to one, delete any existing segment maps.

-f  Force checking of the filesystem. Normally, if a file system is cleanly unmounted, the kernel will set a “clean flag” in the file system superblock and fsck_ffs will not check the file system. This option forces fsck_ffs to check the file system, regardless of the state of the clean flag.

-m mode
    Use the mode specified in octal as the permission bits to use when creating the lost+found directory rather than the default 1700. In particular, systems that wish to have lost files accessible by all users on the system should use a less restrictive set of permissions such as 755.

-n  Assume a “no” response to all questions asked by fsck_ffs except for “CONTINUE?”, which is assumed to be affirmative. The filesystem will not be opened for writing. This is the default for file systems to be checked that are concurrently mounted writable.

-p  Enter preen mode: fsck_ffs will check the filesystem on the special (raw) device listed on the command line and will make minor repairs without human intervention. Any major problems will cause fsck_ffs to exit with a non-zero exit code, so as to alert any invoking program or script that human intervention is required.

-y  Assume a “yes” response to all questions asked by fsck_ffs; this should be used with great caution as this is a free license to continue after essentially unlimited trouble has been encountered.

If neither of the -y or -n options are specified, the user may force fsck_ffs to assume an answer of “yes” to all the remaining questions by replying to a question with a value of “F”.

In interactive mode, fsck_ffs will list the conversion to be made and ask whether the conversion should be done. If a negative answer is given, no further operations are done on the file system. In preen mode, the conversion is listed and done if possible without user interaction. Conversion in preen mode is best used when all the file systems are being converted at once. The format of a file system can be determined from the first line of output from dumpfs(8).

Inconsistencies checked are as follows:

1.  Blocks claimed more than once by inodes or the free map.
2.  Blocks claimed by an inode outside the range of the file system.
3.  Incorrect link counts.
4.  Size checks:
    Directory size not a multiple of DIRBLKSIZ.
    Partially truncated file.
5.  Bad inode format.
6.  Blocks not accounted for anywhere.
7.  Directory checks:
    File pointing to unallocated inode.
    Inode number out of range.
    Dot or dot-dot not the first two entries of a directory or having the wrong inode number.
8.  Super Block checks:
    More blocks for inodes than there are in the file system.
    Bad free block map format.
    Total free block and/or free inode count incorrect.

Orphaned files and directories (allocated but unreferenced) are, with the operator's concurrence, reconnected by placing them in the lost+found directory. The name assigned is the inode number. If the lost+found directory does not exist, it is created. If there is insufficient space, its size is increased.

Because of inconsistencies between the block device and the buffer cache, the raw device should always be used.

DIAGNOSTICS
The diagnostics produced by fsck_ffs are fully enumerated and explained in Appendix A of Fsck - The UNIX File System Check Program.

SEE ALSO
fs(5), fstab(5), fsck(8), fsdb(8), growfs(8), mount_ffs(8), newfs(8), rc(8), scan_ffs(8)